<?php
/*
Plugin Name: aNobii WordPress Widget
Plugin URI: http://www.jhack.it/*
Description: The first plugin which integrates aNobii in Wordpress as a widget
Author: Giacomo Boccardo
Version: 0.2
Author URI: http://www.jhack.it


Copyright 2007  Giacomo Boccardo  (email : gboccard@gmail.com)

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

*/



// Variabili
define('anobiiDirpath','/wp-content/plugins' . strrchr(dirname(__FILE__),'/') . '/');


define("key_anobii_url", "anobii_url", true);
define("key_nBooks", "nBooks", true);

define("anobii_url_default", "", true);
define("anobii_nBooks_default", 6, true);

add_option(key_anobii_url, anobii_url_default, "Default aNobii profile URL");
add_option(key_nBooks, anobii_nBooks_default, "Number of books to display");

if ( get_option(key_nBooks) == "" ) update_option(key_nBooks, 6);


function anobii_options_page() {
	
	// If it's called after a POST...
 	if (isset($_POST['info_update'])) {

		// Update the URL
		$anobii_url = $_POST[key_anobii_url];
		if ($anobii_url == '')
			$anobii_url = anobii_url_default;
		update_option(key_anobii_url, $anobii_url);


		// Update the URL
		$nBooks = $_POST[key_nBooks];
		if ($nBooks == '')
			$nBooks = anobii_nBooks_default;
		update_option(key_nBooks, $nBooks);
		
		
		// Update message
		echo "<div class='updated'><p><strong>aNobii Options Updated</strong></p></div>";
	}
	
	
	
	?>
			
		
	<form method="post" action="options-general.php?page=aNobii.php">

		<div class="wrap">
			<h2>aNobii Plugin Options</h2>
			<p>
				In the following extremely complex form you need to specify the url to the main page of your aNobii's profile using the <strong>alphanumeric format</strong>. 
				<br/>
				If you chose a short format for your aNobii url (e.g.: <a href="http://www.anobii.com/people/jhack">http://www.anobii.com/people/jhack</a> ) you must retrieve your user-id from the Feed RSS url near to the bottom of your aNobii's Home Profile.
				<br />
				Therefore the url you must provide here must be something like <a href="http://www.anobii.com/people/010c51b082b89840a7"> http://www.anobii.com/people/010c51b082b89840a7 </a>.
			
			</p>
			<br/>
			<br/>

			<label for="<?php echo key_anobii_url; ?>">URL (with alphanumeric ID):</label>

			<?php
				echo "<input type='text' size='50' ";
				echo "name='".key_anobii_url."' ";
				echo "id='".key_anobii_url."' ";
				echo "value='".stripslashes(get_option(key_anobii_url))."' />\n";
			?>
			
			<br/>
			<br/>

			<label for="<?php echo key_nBooks; ?>">Number of books to display:</label>
			<select id="<?php echo key_nBooks; ?>" name="<?php echo key_nBooks; ?>">
				<?php

					for ($i=1; $i<11; $i++)
					{
						$selected = "";
						if ( $i == get_option(key_nBooks) ) $selected="selected=selected";
						echo "<option value='$i' $selected>$i</option>";
					}
				?>
			</select>	
										
			<p class="submit">
				<input type='submit' name='info_update' value='Update Options' />
			</p>
		</div>
	</form>
		
	
	<?php
}




function anobii_options_menu() {
	add_options_page('aNobii Plugin Options', 'aNobii Plugin', 8, basename(__FILE__), 'anobii_options_page');
}




function anobii_widget()
{

	?>
	
	<li id="anobii" class="widget widget_anobii">
		<h2 class="widgettitle">aNobii</h2>


		<div id="anobiiContent">


		</div>
		
		
		<?php 
		
			// http://www.anobii.com/people/$uid
			$uid = basename(get_option(key_anobii_url));
			$nBooks = get_option(key_nBooks);
			$curPath = get_option('siteurl').anobiiDirpath;
				

			echo "	<script src=\"" . get_option('siteurl') . "/wp-content/plugins/anobii-wordpress-widget/aNobiiWidget.js\" type=\"text/javascript\"></script>\n";

			echo "	<script type=\"text/javascript\">init(\"$curPath\", \"$uid\", $nBooks);</script>\n";
		
		?>

	</li>
	
	<?php
}


function anobii_widget_init()
{	
	// Check if the environment supports widgets
	if (!function_exists('register_sidebar_widget'))
    	return;

	register_sidebar_widget('aNobii Widget', 'anobii_widget');
}


function anobii_stylesheet() 
{
	$curPath = get_option('siteurl').anobiiDirpath;
	
	echo "<link rel=\"stylesheet\" href=\"".$curPath."css/aNobiiStyle.css\" type=\"text/css\" media=\"screen\" />";	
}


// Create the option menu
add_action('admin_menu', 'anobii_options_menu' );

// Initialize the widget
add_action('plugins_loaded', 'anobii_widget_init');

// Add stylesheet to head
add_action('wp_head', 'anobii_stylesheet');



?>
